<template>
    <div>
        <v-row>
            <v-col>
                <v-card>
                    <v-list-item two-line>
                        <v-list-item-content>
                            <div class="subtitle-1 text--secondary font-weight-bold mb-4">{{ $t('total_sales') }}</div>
                            <v-list-item-title class="headline mb-1">
                                <v-skeleton-loader
                                    :loading="loadingOverall"
                                    type="text"
                                >
                                    MYR {{ totalSale | currency }}
                                </v-skeleton-loader>
                            </v-list-item-title>
                        </v-list-item-content>

                        <v-list-item-avatar
                            size="60"
                            color="pink darken-1"
                        >
                            <v-icon large color="white">mdi-currency-usd</v-icon>
                        </v-list-item-avatar>
                    </v-list-item>
                </v-card>
            </v-col>

            <v-col>
                <v-card>
                    <v-list-item two-line>
                        <v-list-item-content>
                            <div class="subtitle-1 text--secondary font-weight-bold mb-4">{{ $t('total_order') }}</div>
                            <v-list-item-title class="headline mb-1">
                                <v-skeleton-loader
                                    :loading="loadingOverall"
                                    type="text"
                                >
                                    {{ totalOrder }}
                                </v-skeleton-loader>
                            </v-list-item-title>
                        </v-list-item-content>

                        <v-list-item-avatar
                            size="60"
                            color="purple darken-1"
                        >
                            <v-icon large color="white">mdi-cart</v-icon>
                        </v-list-item-avatar>
                    </v-list-item>
                </v-card>
            </v-col>

            <v-col>
                <v-card>
                    <v-list-item two-line>
                        <v-list-item-content>
                            <div class="subtitle-1 text--secondary font-weight-bold mb-4">{{ $t('total_tx') }}</div>
                            <v-list-item-title class="headline mb-1">
                                <v-skeleton-loader
                                    :loading="loadingOverall"
                                    type="text"
                                >
                                    {{ totalTransaction }}
                                </v-skeleton-loader>
                            </v-list-item-title>
                        </v-list-item-content>

                        <v-list-item-avatar
                            size="60"
                            color="blue darken-1"
                        >
                            <v-icon large color="white">mdi-bank-transfer</v-icon>
                        </v-list-item-avatar>
                    </v-list-item>
                </v-card>
            </v-col>
        </v-row>
        <v-row>
            <v-col>
                <v-container fluid class="fill-height px-0">
                    <v-row>
                        <v-col cols="12">
                            <v-card class="sales" raised>
                                <v-card-title class="white">
                                    <span>{{ $t('overall_sales') }}</span>
                                </v-card-title>

                                <v-toolbar flat height="100">
                                    <v-col cols="5">
                                        <v-menu
                                            ref="salesMenuRef"
                                            v-model="totalSalesDateMenu"
                                            :close-on-content-click="false"
                                            :return-value.sync="salesDateRange"
                                            transition="scale-transition"
                                            min-width="250px"
                                            disabled
                                        >
                                            <template v-slot:activator="{ on, attrs }">
                                                <v-text-field
                                                    v-model="salesDateRangeText"
                                                    prepend-icon="mdi-calendar"
                                                    :label="$t('filter_by', [$t('date')])"
                                                    readonly
                                                    hide-details
                                                    v-bind="attrs"
                                                    v-on="on"
                                                    outlined
                                                >
                                                </v-text-field>
                                            </template>
                                            <v-date-picker
                                                range
                                                v-model="salesDateRange"
                                            >
                                                <v-spacer></v-spacer>
                                                <v-btn class="primary" @click="totalSalesDateMenu = false">
                                                    {{ $t('cancel') }}
                                                </v-btn>
                                                <v-btn class="primary" @click="onTotalSalesDateChange">
                                                    {{ $t('ok') }}
                                                </v-btn>
                                            </v-date-picker>
                                        </v-menu>
                                    </v-col>
                                </v-toolbar>
                                <v-progress-linear :active="loadingTotalSalesChart" indeterminate></v-progress-linear>
                                <sales-chart class="pa-5" :chart-data="sales"></sales-chart>
                            </v-card>
                        </v-col>

                        <v-col cols="12">
                            <v-card class="ranking" raised>
                                <v-card-title>
                                    <span>{{ $t('overall_orders') }}</span>
                                </v-card-title>

                                <v-toolbar flat height="100">
                                    <v-col cols="5">
                                        <v-menu
                                            ref="orderMenuRef"
                                            v-model="totalOrderDateMenu"
                                            :close-on-content-click="false"
                                            :return-value.sync="orderDateRange"
                                            transition="scale-transition"
                                            min-width="250px"
                                            disabled
                                        >
                                            <template v-slot:activator="{ on, attrs }">
                                                <v-text-field
                                                    v-model="orderDateRangeText"
                                                    prepend-icon="mdi-calendar"
                                                    :label="$t('filter_by', [$t('date')])"
                                                    readonly
                                                    hide-details
                                                    v-bind="attrs"
                                                    v-on="on"
                                                    outlined
                                                >
                                                </v-text-field>
                                            </template>
                                            <v-date-picker
                                                range
                                                v-model="orderDateRange"
                                            >
                                                <v-spacer></v-spacer>
                                                <v-btn class="primary" @click="totalOrderDateMenu = false">
                                                    {{ $t('cancel') }}
                                                </v-btn>
                                                <v-btn class="primary" @click="onTotalOrderDateChange">
                                                    {{ $t('ok') }}
                                                </v-btn>
                                            </v-date-picker>
                                        </v-menu>
                                    </v-col>
                                </v-toolbar>
                                <v-progress-linear :active="loadingTotalOrderChart" indeterminate></v-progress-linear>
                                <order-chart class="pa-5" :chart-data="orders"></order-chart>
                            </v-card>
                        </v-col>
                    </v-row>
                </v-container>
            </v-col>
        </v-row>
    </div>
</template>

<script>
    import SalesChart from "../../../plugins/charts/sales";
    import OrderChart from "../../../plugins/charts/orders";
    import moment from 'moment';

    export default {
        name: "AdminHome",

        components: {
            SalesChart, OrderChart
        },

        data: () => ({
            loadingOverall: false,
            totalSale: 0,
            totalOrder: 0,
            totalTransaction: 0,
            loaded: false,
            sales: {},
            orders: {},
            loadingTotalSalesChart: false,
            totalSalesDateMenu: false,
            salesDateRange: [
                moment().startOf('month').format('YYYY-MM-DD'),
                moment().endOf('month').format('YYYY-MM-DD')
            ],
            loadingTotalOrderChart: false,
            totalOrderDateMenu: false,
            orderDateRange: [
                moment().startOf('month').format('YYYY-MM-DD'),
                moment().endOf('month').format('YYYY-MM-DD')
            ]
        }),

        computed: {
            salesDateRangeText () {
                return this.salesDateRange.join(' ~ ')
            },

            orderDateRangeText () {
                return this.orderDateRange.join(' ~ ')
            },
        },

        mounted() {
            // this.getOverall();
            // this.getTotalSales();
            // this.getTotalOrders();
        },

        methods: {
            // getOverall() {
            //     axios.get('api/chart/overall')
            //         .then(({ data }) => {
            //             this.totalSale = data.sales;
            //             this.totalOrder = data.orders;
            //             this.totalTransaction = data.transactions;
            //             this.loadingOverall = false;
            //         })
            // },

            onTotalSalesDateChange() {
                this.$refs.salesMenuRef.save(this.salesDateRange);

                this.getTotalSales();
            },

            // getTotalSales() {
            //     this.loadingTotalSalesChart = true;
            //
            //     axios.get('api/chart/sales', {
            //         params: {
            //             from: this.salesDateRange[0],
            //             to: this.salesDateRange[1]
            //         }
            //     })
            //         .then(({ data }) => {
            //             this.sales = ({
            //                 datasets: [{
            //                     borderColor: "#5e72e4",
            //                     pointBackgroundColor: "#ffffff",
            //                     showLine: true,
            //                     fill: false,
            //                     data: data.data
            //                 }]
            //             });
            //
            //             this.loadingTotalSalesChart = false;
            //         })
            // },

            onTotalOrderDateChange() {
                this.$refs.orderMenuRef.save(this.orderDateRange);

                this.getTotalOrders();
            },

            // getTotalOrders() {
            //     this.loadingTotalOrderChart = true;
            //
            //     axios.get('api/chart/orders', {
            //         params: {
            //             from: this.orderDateRange[0],
            //             to: this.orderDateRange[1]
            //         }
            //     })
            //         .then(({ data }) => {
            //             this.orders = ({
            //                 datasets: [{
            //                     backgroundColor: "#FF6E40",
            //                     data: data.data
            //                 }]
            //             });
            //
            //             this.loadingTotalOrderChart = false;
            //         })
            // }
        }
    }
</script>

<style scoped>
    .sales {
        background-color: #17254c;
    }
    .ranking {
        background-color: #ffffff;
    }
</style>
